Open Lighting Architecture: ola::usb::JaRulePortHandle Class Reference

| Open Lighting Architecture 0.10.9

Loading...
Searching...
No Matches
Public Member Functions | List of all members
ola::usb::JaRulePortHandle Class Reference

## Detailed Description

Represents a DMX/RDM port on a Ja Rule device.

Inheritance diagram for ola::usb::JaRulePortHandle:

## Public Member Functions
| JaRulePortHandle (class JaRuleWidgetPort *parent_port, const ola::rdm::UID &uid, uint8_t physical_port)
| Create a new Ja Rule Port Handle.
void | SendRDMRequest (ola::rdm::RDMRequest *request, ola::rdm::RDMCallback *on_complete)
| Send a RDM command.
void | RunFullDiscovery (ola::rdm::RDMDiscoveryCallback *callback)
| Start a full discovery operation.
void | RunIncrementalDiscovery (ola::rdm::RDMDiscoveryCallback *callback)
| Start an incremental discovery operation.
bool | SendDMX (const DmxBuffer &buffer)
| Send DMX data from this widget.
bool | SetPortMode (JaRulePortMode new_mode)
| Change the mode of the port.

## Member Function Documentation

## ◆ RunFullDiscovery()

void ola::usb::JaRulePortHandle::RunFullDiscovery | ( | ola::rdm::RDMDiscoveryCallback * | callback | ) |
| virtual

Start a full discovery operation.

Parameters

  callback | The callback run when discovery completes. This may run immediately in some implementations.

Implements ola::rdm::DiscoverableRDMControllerInterface.

## ◆ RunIncrementalDiscovery()

void ola::usb::JaRulePortHandle::RunIncrementalDiscovery | ( | ola::rdm::RDMDiscoveryCallback * | callback | ) |
| virtual

Start an incremental discovery operation.

Parameters

  callback | The callback run when discovery completes. This may run immediately in some implementations.

Implements ola::rdm::DiscoverableRDMControllerInterface.

## ◆ SendDMX()

bool ola::usb::JaRulePortHandle::SendDMX | ( | const DmxBuffer & | buffer | ) |

Send DMX data from this widget.

Parameters

  buffer | The DmxBuffer containing the data to send.

Returns
  true if the data was sent, false otherwise.

## ◆ SendRDMRequest()

void ola::usb::JaRulePortHandle::SendRDMRequest | ( | ola::rdm::RDMRequest * | request,
|  | ola::rdm::RDMCallback * | on_complete )
| virtual

Send a RDM command.

Parameters

  request | the RDMRequest, ownership is transferred.
  on_complete | The callback to run when the request completes.

Implementors much ensure that the callback is always run at some point. In other words, there must be no way that a request can be dropped in such a way that the callback is never run. Doing so will either block all subsequent requests, or leak memory depending on the implementation.

Also the implementor of this class may want to re-write the transaction #, and possibly the UID (changing src UIDs isn't addressed by the RDM spec).

The RDMRequest may be a DISCOVERY_COMMAND, if the implementation does not support DISCOVERY_COMMANDs then the callback should be run with ola::rdm::RDM_PLUGIN_DISCOVERY_NOT_SUPPORTED.

Implements ola::rdm::RDMControllerInterface.

## ◆ SetPortMode()

bool ola::usb::JaRulePortHandle::SetPortMode | ( | JaRulePortMode | new_mode | ) |

Change the mode of the port.

Todo
  I need to think about how to return errors from this since it's async.

The documentation for this class was generated from the following files:

- libs/usb/JaRulePortHandle.h
- libs/usb/JaRulePortHandle.cpp